<?php

/**
 * 
 * @version		1.0.0
 * @package		Joomla
 * @subpackage	GK AJAX
 * @copyright	Copyright (C) 2008 - 2009 GavickPro. All rights reserved.
 * @license		GNU/GPL
 * 
 * ==========================================================================
 * 
 * Plugin for GK News module
 * 
 */
 
// no direct access
defined('_JEXEC') or die('Restricted access');

class GK_HeadlinesPlugin
{
	var $helpers_path;
	var $_config;
	var $_headlinesArray;
	
	function init()
	{		
		// module helpers directory path
		$this->helpers_path = JPATH_SITE.DS.'modules'.DS.'mod_gk_headlines'.DS.'helpers'.DS;
		// getting variables from $_POST table
		$this->_config["total"] = 				JRequest::getCmd('total', null, 'post');//1;
		$this->_config["page"] = 				JRequest::getCmd('page', null, 'post');//1;
		// getting module ID
		$module_id = JRequest::getCmd('mod_table_id', null, 'get');//1;
		// importing JParamete class
		jimport('joomla.html.parameter');
		// getting parameters from database
		$db =& JFactory::getDBO();
		$db->setQuery('SELECT params FROM #__modules WHERE id = '.$module_id.' LIMIT 1;');
		$row = $db->loadRow();
		// creating $parameters object
		$parameters = new JParameter($row[0]);
		// getting rest of parameters from $parameters object
		$this->_config["categories"]           =          $parameters->get('categories',            '');
		$this->_config["item_amount"]          = (string) $parameters->get('item_amount',           5);
		// Interface settings
		$this->_config["ajax_buttons"]         = (bool)   $parameters->get('ajax_buttons',          1);
		// Content settings
		$this->_config["title_limit"]          = (int)    $parameters->get('title_limit',           30);
		$this->_config["title_limit_type"]     = (int)    $parameters->get('title_limit_type',      1);
		$this->_config["date_type"]            = (string) $parameters->get('date_type',             'created');
		$this->_config["date_format"]          = (string) $parameters->get('date_format',           'D, d M Y');
		$this->_config["author_name"]          = (string) $parameters->get('author_name',           'name');
		// Design settings
		$this->_config["item_template"]        =          $parameters->get('item_template',         'layout1.php');
		// Advanced settings
		$this->_config["useCSS"]               = (bool)   $parameters->get('useCSS',                1);
		$this->_config["useMoo"]               = (int)    $parameters->get('useMoo',                2);
		$this->_config["useScript"]            = (int)    $parameters->get('useScript',             2);
		// including helpers
		require_once($this->helpers_path.'db.helper.php');
		require_once($this->helpers_path.'date.helper.php');
		require_once($this->helpers_path.'text.helper.php');
		// validating variables:
		if($this->_config["total"] !== null && $this->_config["page"] !== null)
		{
			$dbHelper = new GKHeadlines_DBHelper();
			// getting section with categories array
			$this->_headlinesArray = $dbHelper->getHeadlinesArrayAJAX($this->_config,$this->_config["total"], $this->_config["page"]);
			
			require_once('default.php');
		}
		else
		{
			echo 'Wrong variables';
		}
	}	
}


$obj = new GK_HeadlinesPlugin();
$obj->init();