<?php

/**
 * 
 * @version		1.0.0
 * @package		Joomla
 * @subpackage	GK AJAX
 * @copyright	Copyright (C) 2008 - 2009 GavickPro. All rights reserved.
 * @license		GNU/GPL
 * 
 * ==========================================================================
 * 
 * Plugin for GK News module
 * 
 */
 
// no direct access
defined('_JEXEC') or die('Restricted access');

class GK_NewsPlugin
{
	var $helpers_path;
	var $_config;
	var $sections;
	var $_categoryArray;
	var $authors;
	
	function init()
	{		
		// module helpers directory path
		$this->helpers_path = JPATH_SITE.DS.'modules'.DS.'mod_gk_news'.DS.'helpers'.DS;
		// getting variables from $_POST table
		$this->_config["section_id"] = 				JRequest::getCmd('section_id', null, 'post');//1;
		$this->_config["cats"]       = 				JRequest::getCmd('cats', null, 'post');//'1,3'; 	
		$this->_config["intro_news_amount"] =		JRequest::getCmd('intro_news_amount', null, 'post');// 1;
		$this->_config["more_news_amount"] =		JRequest::getCmd('more_news_amount', null, 'post');// 3;
		// getting module ID
		$module_id = JRequest::getCmd('mod_table_id', null, 'get');//1;
		// importing JParamete class
		jimport('joomla.html.parameter');
		// getting parameters from database
		$db =& JFactory::getDBO();
		$db->setQuery('SELECT params FROM #__modules WHERE id = '.$module_id.' LIMIT 1;');
		$row = $db->loadRow();
		// creating $parameters object
		$parameters = new JParameter($row[0]);
		// getting rest of parameters from $parameters object
		$this->_config["col_amount"] = 				$parameters->get('col_amount', null);//2;	
		$this->_config["category_order"] = 			$parameters->get('category_order', null);//'title';
		$this->_config["category_order_type"] =		$parameters->get('category_order_type', null);// 'ASC';
		$this->_config["title_limit"] =				$parameters->get('title_limit', null);// 30;	
		$this->_config["title_limit_type"] =		$parameters->get('title_limit_type', null);// 1;
		$this->_config["text_limit"] = 				$parameters->get('text_limit', null);//30;
		$this->_config["text_limit_type"] = 		$parameters->get('text_limit_type', null);//1;
		$this->_config["date_type"] = 				$parameters->get('date_type', null);//'created';
		$this->_config["date_format"] = 			$parameters->get('date_format', null);//'D, d M Y';
		$this->_config["author_name"] = 			$parameters->get('author_name', null);//'name';
		$this->_config["clean_xhtml"] =				$parameters->get('clean_xhtml', null);//1;
		$this->_config["image_generation"] =		$parameters->get('image_generation', null);// 1;
		$this->_config["image_height"] =	 		$parameters->get('image_height', null);// 128;
		$this->_config["image_width"] =				$parameters->get('image_width', null);// 128;
		$this->_config["image_bg"] =				$parameters->get('image_bg', null);// '#fff';
		$this->_config["image_stretch"] =		 	$parameters->get('image_stretch', null);// 1;
		$this->_config["image_quality"] =			$parameters->get('image_quality', null);// 95;
		$this->_config["cache_time"] =				$parameters->get('cache_time', null);// 30;
		$this->_config["category_template"] =		$parameters->get('category_template', null);// 'layout1.php';
		$this->_config["intro_template"] =			$parameters->get('intro_template', null);// 'layout1.php';
		$this->_config["more_template"] =			$parameters->get('more_template', null);// 'layout1.php';
		$this->_config["parse_plugins"] =			$parameters->get('parse_plugins', null);// 0;
		$this->_config["clean_plugins"] =			$parameters->get('clean_plugins', null);// 1;
		// including helpers
		require_once($this->helpers_path.'db.helper.php');
		require_once($this->helpers_path.'date.helper.php');
		require_once($this->helpers_path.'image.helper.php');
		require_once($this->helpers_path.'text.helper.php');
		// validating variables:
		if(
			$this->_config["section_id"] !== null
			&& $this->_config["cats"] !== null
			&& $this->_config["col_amount"] !== null 
			&& $this->_config["category_order"] !== null 
			&& $this->_config["category_order_type"] !== null 
		    && $this->_config["title_limit"] !== null 
			&& $this->_config["title_limit_type"] !== null 
			&& $this->_config["text_limit"] !== null 
			&& $this->_config["text_limit_type"] !== null 
			&& $this->_config["date_type"] !== null 
			&& $this->_config["date_format"] !== null 
			&& $this->_config["author_name"] !== null 
			&& $this->_config["clean_xhtml"] !== null 
			&& $this->_config["image_generation"] !== null 
			&& $this->_config["image_height"] !== null 
			&& $this->_config["image_width"] !== null 
			&& $this->_config["image_bg"] !== null 
			&& $this->_config["image_stretch"] !== null 
			&& $this->_config["image_quality"] !== null 
			&& $this->_config["cache_time"] !== null 
			&& $this->_config["category_template"] !== null 
			&& $this->_config["intro_template"] !== null
			&& $this->_config["more_template"] !== null
			&& $this->_config["parse_plugins"] !== null
			&& $this->_config["clean_plugins"] !== null 
			&& $this->_config["intro_news_amount"] !== null
			&& $this->_config["more_news_amount"] !== null
		)
		{
			$dbHelper = new GKNews_DBHelper();
			$this->sections = $dbHelper->getSectionArrayAJAX($this->_config["section_id"], $this->_config["cats"], $this->_config["category_order"], $this->_config["category_order_type"]);
			$this->_categoryArray = $dbHelper->getCategoryArrayAJAX($this->sections, $this->_config["category_order"], $this->_config["category_order_type"], $this->_config["date_type"], $this->_config["intro_news_amount"], $this->_config["more_news_amount"]);
			$this->authors = $dbHelper->getAuthorArrayAJAX($this->_categoryArray, $this->_config["author_name"]);
			
			require_once('default.php');
		}
		else
		{
			echo 'Wrong variables';
		}
	}	
}


$obj = new GK_NewsPlugin();
$obj->init();