<?php

/**
* Gavick GK Categories - helper class
* @package Joomla!
* @Copyright (C) 2009 Gavick.com
* @ All rights reserved
* @ Joomla! is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.0.0 $
**/

// no direct access
defined('_JEXEC') or die('Restricted access');
// Main class
class GKCategoriesHelper
{
	var $config;
	var $results;

	/**
	 * 
	 *	INITIALIZATION
	 * 
	 **/
	
	function init()
	{		
		// configuration array
		$this->config = array(
			'module_unique_id' => '',				            
            'sections' => '',
			'cat_amount' => '5',
            'col_amount' => '1',
			'cat_order' => 'title',
			'cat_order_type' => 'asc',
			'section_order' => 'title',
			'section_order_type' => 'asc',
			'layout' => 'list_standard'
		);	
		
		$this->results = false;
	}
	
	/**
	 * 
	 *	VARIABLES VALIDATION
	 * 
	 **/
	
	function validateVariables(&$params)
	{
		$this->config['module_unique_id'] = $params->get('module_unique_id','weather1'); // unique ID
		$this->config['sections'] = $params->get('sections','');
		$this->config['cat_amount'] = $params->get('cat_amount','5');
		$this->config['col_amount'] = $params->get('col_amount','1');
		$this->config['section_order'] = $params->get('section_order','title');
		$this->config['section_order_type'] = $params->get('section_order_type','asc');
		$this->config['cat_order'] = $params->get('cat_order','title');
		$this->config['cat_order_type'] = $params->get('cat_order_type','asc');
		$this->config['layout'] = $params->get('layout','list_standard');
	}
	
	/**
	 * 
	 *	GETTING DATA
	 * 
	 **/
		
	function getData()
	{
		$db =& JFactory::getDBO();
		// generating ordering clause
		$section_order = ($this->config['layout'] == 'list_section') ? 's.'.$this->config['section_order'].' '.$this->config['section_order_type'].',' : '';
		// generating ordering clause
		$category_order = 'c.'.$this->config['cat_order'].' '.$this->config['cat_order_type'];
		// generating section id clause
		$sectionid_clause = '';
		// iteration
		for($i = 0; $i < count($this->config['sections']); $i++)
		{
			$sectionid_clause .= ($i == count($this->config['sections']) - 1) ? ' s.id = '.$this->config['sections'][$i].' ' : ' s.id = '.$this->config['sections'][$i].' OR ';
		}	
		// generating SQL query
		$query =   'SELECT 
						c.title AS cat_name,
			        	c.id AS cat_id,
						c.section AS cat_section,
						s.title AS section_name
					FROM
						#__categories AS c
					INNER JOIN
						#__sections AS s ON s.id = c.section
					WHERE
			        	c.access <= 0 AND
						s.access <= 0 AND
						c.published = 1 AND
			        	s.published = 1 AND
			        	( '.$sectionid_clause.' )
					ORDER BY
			        	'.$section_order.'
						'.$category_order;							
		// running SQL query	
		$db->setQuery($query);
		// getting results rows
		$rows = $db->loadObjectList();
		// parsing rows
		if(count($rows) > 0)
		{
			// creating array for results
			$result_array = array();
			// rows iteration
			foreach($rows as $row)
			{
				$tmp = array(
					"cat_name" => $row->cat_name,
					"cat_id" => $row->cat_id,
					"cat_section" => $row->cat_section,
					"section_name" => $row->section_name
				);
				
				array_push($result_array, $tmp);
			}
			
			$this->results = $result_array;
		}
	}
	
	/**
	 * 
	 *	RENDERING LAYOUT
	 * 
	 **/
	
	function renderLayout()
	{	
		// GENERATING FINAL XHTML CODE START
		require(JModuleHelper::getLayoutPath('mod_gk_categories', $this->config["layout"]));
	}
}

?>