<?php

/**
* GK Headlines - main helper class
* @package Joomla!
* @Copyright (C) 2009 Gavick.com
* @ All rights reserved
* @ Joomla! is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.0.0 $
**/

// no direct access
defined('_JEXEC') or die('Restricted access');
// import com_content route helper
require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');
// import JString class for UTF-8 problems
jimport('joomla.utilities.string'); 
// Main class
class GKHeadlines_MainHelper
{
	// headlines array (stores information about headlines)
	var $_headlinesArray;
	// config array (stores information about module settings)
	var $_config;
	// constructor
	function GKHeadlines_MainHelper()
	{
		// creating array for sections categories
		$this->_headlinesArray = array();
		// creating array for configuration
		$this->_config = array();
	}
	// method to get module settings
	function getParams(&$params)
	{
		// Basic module settings
		$this->_config["moduleclass_sfx"]      = (string) $params->get('moduleclass_sfx',       '');
		$this->_config["module_unique_id"]     = (string) $params->get('module_unique_id',      'gknews1');
		// Content source settings
		$this->_config["categories"]           =          $params->get('categories',            '');
		$this->_config["item_amount"]          = (string) $params->get('item_amount',           5);
		// Interface settings
		$this->_config["ajax_buttons"]         = (bool)   $params->get('ajax_buttons',          1);
		// Content settings
		$this->_config["title_limit"]          = (int)    $params->get('title_limit',           30);
		$this->_config["title_limit_type"]     = (int)    $params->get('title_limit_type',      1);
		$this->_config["date_type"]            = (string) $params->get('date_type',             'created');
		$this->_config["date_format"]          = (string) $params->get('date_format',           'D, d M Y');
		$this->_config["author_name"]          = (string) $params->get('author_name',           'name');
		// Design settings
		$this->_config["item_template"]        =          $params->get('item_template',         'layout1.php');
		// Advanced settings
		$this->_config["useCSS"]               = (bool)   $params->get('useCSS',                1);
		$this->_config["useMoo"]               = (int)    $params->get('useMoo',                2);
		$this->_config["useScript"]            = (int)    $params->get('useScript',             2);
		// Data validation
		$this->_config["total"]                = 0;
	}
	// method to get module data
	function getDatas()
	{
		// creating Database Helper instance
		$dbHelper = new GKHeadlines_DBHelper($this->_config);
		// getting section with categories array
		$this->_headlinesArray = $dbHelper->getHeadlinesArray($this->_config);
		// getting total amount of articles
		$this->_config["total"] = $dbHelper->getTotalAmount($this->_config);
	}
	// method to render module
	function renderModule(&$module)
	{
		// creating text helper
		$textHelper = new GKHeadlines_TextHelper();
		// creating and initializing date helper
		$dateHelper = new GKHeadlines_DateHelper();
		$dateHelper->init();
		// GENERATING FINAL XHTML CODE START
		// create instances of basic Joomla! classes
		$document =& JFactory::getDocument();
		$uri =& JURI::getInstance();
		// add stylesheets to document header
		if($this->_config["useCSS"] == 1){
			$document->addStyleSheet( $uri->root().'modules/mod_gk_headlines/css/style.css', 'text/css' );
		}
		// init $headData variable
		$headData = false;
		// add scripts with automatic mode to document header
		if($this->_config['useMoo'] == 2)
		{
			// getting module head section datas
			unset($headData);
			$headData = $document->getHeadData();
			// generate keys of script section
			$headData_keys = array_keys($headData["scripts"]);
			// set variable for false
			$mootools_founded = false;
			// searching phrase mootools in scripts paths
			for($i = 0;$i < count($headData_keys); $i++)
			{
				if(preg_match('/mootools/i', $headData_keys[$i]))
				{
					// if founded set variable to true and break loop
					$mootools_founded = true;
					break;
				}
			}
			// if mootools file doesn't exists in document head section
			if(!$mootools_founded)
			{
				// add new script tag connected with mootools from module
				$headData["scripts"][$uri->root().'modules/mod_gk_headlines/scripts/mootools.js'] = "text/javascript";
				// if added mootools from module then this operation have sense
				$document->setHeadData($headData);
			}
		}
		
		if($this->_config['useScript'] == 2)
		{
			// getting module head section datas
			unset($headData);
			$headData = $document->getHeadData();
			// generate keys of script section
			$headData_keys = array_keys($headData["scripts"]);
			// set variable for false
			$engine_founded = false;
			// searching phrase mootools in scripts paths
			if(array_search($uri->root().'modules/mod_gk_headlines/scripts/engine.js', $headData_keys) > 0)
			{
				// if founded set variable to true
				$engine_founded = true;
			}
			// if mootools file doesn't exists in document head section
			if(!$engine_founded)
			{
				// add new script tag connected with mootools from module
				$headData["scripts"][$uri->root().'modules/mod_gk_headlines/scripts/engine.js'] = "text/javascript";
				// if added mootools from module then this operation have sense
				$document->setHeadData($headData);
			}
		}
		// loading layout for content
		require(JModuleHelper::getLayoutPath('mod_gk_headlines', 'default'));
		// loading layout for scripts
		require(JModuleHelper::getLayoutPath('mod_gk_headlines', 'scripts'));	
	}
}