<?php

/**
* GK News - database helper class
* @package Joomla!
* @Copyright (C) 2009 Gavick.com
* @ All rights reserved
* @ Joomla! is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.0.0 $
**/

// no direct access
defined('_JEXEC') or die('Restricted access');
// Main class
class GKNews_DBHelper
{
	var $_db;
	var $_config;
	
	function GKNews_DBHelper()
	{
		$this->_db =& JFactory::getDBO();
	} 
	
	function getSectionArray($config)
	{
		// generating ordering clause
		$section_order = 's.'.$config['section_order'].' '.$config['section_order_type'];
		// generating ordering clause
		$category_order = 'c.'.$config['category_order'].' '.$config['category_order_type'];
		// generating section id clause
		$sectionid_clause = '';
		// iteration
		for($i = 0; $i < count($config['sections']); $i++)
		{
			$sectionid_clause .= ($i == count($config['sections']) - 1) ? ' s.id = '.$config['sections'][$i].' ' : ' s.id = '.$config['sections'][$i].' OR ';
		}	
		// generating SQL query
		$query =   'SELECT 
						c.title AS cat_name,
			        	c.id AS cat_id,
						c.section AS cat_section,
						s.title AS section_name
					FROM
						#__categories AS c
					INNER JOIN
						#__sections AS s ON s.id = c.section
					WHERE
			        	c.access <= 0 AND
						s.access <= 0 AND
						c.published = 1 AND
			        	s.published = 1 AND
			        	( '.$sectionid_clause.' )
					ORDER BY
			        	'.$section_order.',
						'.$category_order;							
		// running SQL query	
		$this->_db->setQuery($query);
		// getting results rows
		$rows = $this->_db->loadObjectList();
		// parsing rows
		if(count($rows) > 0)
		{
			// creating array for results
			$result_array = array();
			// rows iteration
			foreach($rows as $row)
			{
				$tmp = array(
					"cat_name" => $row->cat_name,
					"cat_id" => $row->cat_id,
					"cat_section" => $row->cat_section,
					"section_name" => $row->section_name
				);
				
				array_push($result_array, $tmp);
			}
			
			//echo '<pre>';
			//echo '====SECTION QUERY====';
			//print_r($result_array);
			//echo '</pre>';
			// returnig results in array
			return $result_array;
		}
		else
		{
			// Error - no sections or categories
		}
	}
	//
	function getCategoryArray($config, $sectionArray)
	{
		// getting information about user
		$user =& JFactory::getUser();
		$userId = (int) $user->get('id');
		$aid = $user->get('aid', 0);
		// getting access config
		$contentConfig = &JComponentHelper::getParams( 'com_content' );
		$access	= !$contentConfig->get('show_noauth');
		// getting date variables
		$nullDate	= $this->_db->getNullDate();
		$date =& JFactory::getDate();
		$now = $date->toMySQL();
			
		// initializing result array
		$result_array = array();
		// initializing helper counter array for limiting category queries
		$counter = array();
		
		// creating counter items
		for($i = 0; $i < count($config['sections']); $i++)
		{
			$counter["section".$config['sections'][$i]] = 0;
		}
		// generating queries for every category
		for($i = 0; $i < count($sectionArray);$i++)
		{
			// if script generate queries for less categories than limit amout of categories
			if($counter["section".$sectionArray[$i]["cat_section"]] < $config["cat_amount"])
			{
				// creating array for category articles
				if(!isset($result_array["section".$sectionArray[$i]["cat_section"]]['cat'.$sectionArray[$i]["cat_id"]]))
				{
					$result_array["section".$sectionArray[$i]["cat_section"]]['cat'.$sectionArray[$i]["cat_id"]] = array();
				}
				
				// generating ordering clause
				$category_order = 'c.'.$config['category_order'].' '.$config['category_order_type'];
				
				// preparing query
				$query =   'SELECT 
								a.id AS art_id,
								a.title AS art_title, 
								a.introtext AS art_text,
								'.(($config['date_type'] == 'created') ? 'a.created' : 'a.modified').' AS art_date,
								a.created_by AS art_author,
								a.hits AS art_hits,
								a.sectionid AS art_sectionid,
								CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) 
								ELSE a.id END AS art_slug, 
								CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(":", c.id, c.alias) 
								ELSE c.id END AS cat_slug
							FROM 
								#__content AS a 
							INNER JOIN 
								#__categories AS c ON c.id = a.catid 
							WHERE 
							
							a.state = 1 AND 
							( a.publish_up = '.$this->_db->Quote($nullDate).' OR a.publish_up <= '.$this->_db->Quote($now).' ) AND 
							( a.publish_down = '.$this->_db->Quote($nullDate).' OR a.publish_down >= '.$this->_db->Quote($now).' ) AND 
							'.($access ? ' a.access <= ' .(int) $aid. ' AND c.access <= ' .(int) $aid . ' AND ' : '').' 
							c.published = 1 AND 
							a.catid = '.$sectionArray[$i]["cat_id"].'
							
							ORDER BY 
								'.$category_order.', 
								a.created DESC';
				// run query
				$limit = ($config["intro_news_amount"] + $config["more_news_amount"] <= 15) ? $config["intro_news_amount"] + $config["more_news_amount"] : 15;
				$this->_db->setQuery($query,0,$limit);
				// getting query result
				$rows = $this->_db->loadObjectList();
				
				// increasing value of counter
				$counter["section".$sectionArray[$i]["cat_section"]] += 1;
				// parsing rows
				if(count($rows) > 0)
				{
					// rows iteration
					foreach($rows as $row)
					{
						$tmp = array(
							"art_id" => $row->art_id,
							"art_title" => $row->art_title,
							"art_text" => $row->art_text,
							"art_date" => $row->art_date,
							"art_author" => $row->art_author,
							"art_hits" => $row->art_hits,
							"art_sectionid" => $row->art_sectionid,
							"art_slug" => $row->art_slug,
							"cat_slug" => $row->cat_slug
						);
						
						array_push($result_array["section".$tmp["art_sectionid"]]['cat'.$sectionArray[$i]["cat_id"]], $tmp);
					}
				}
				else
				{
					// Error - no categories or no articles
				}	
			}
		}
		
		//echo '<pre>';
		//echo '====CATEGORY QUERY====';
		//print_r($result_array);
		//echo '</pre>';
		// returnig results in array
		return $result_array;
	}
	//
	function getAuthorArray($config, $categoryArray)
	{
		// result array
		$result_array = array();
		// preparing array for authors IDs
		$authorIDs = array();
		// search author items
		foreach($categoryArray as $section)
		{
			foreach($section as $category)
			{
				foreach($category as $article)				
				{
					if(array_search($article["art_author"], $authorIDs) === FALSE)
					{
						array_push($authorIDs, $article["art_author"]);
					}
				}
			}
		}
		
		//echo '<pre>';
		//echo '====AUTHORS====';
		//print_r($authorIDs);
		//echo '</pre>';
		
		// variable for cluase
		$authorid_clause = '';
		// generating where clause 
		for($i = 0; $i < count($authorIDs); $i++)
		{
			$authorid_clause .= ($i == count($authorid_clause) - 1) ? ' u.id = '.$authorIDs[$i].' ' : ' u.id = '.$authorIDs[$i].' OR ';
		}
		// generating SQL query
		$query =   'SELECT 
						u.id AS id, 
						u.'.($config["author_name"]).' AS name 
					FROM 
						#__users AS u
					WHERE
					'.$authorid_clause;
		// getting data from database
		$this->_db->setQuery($query);
		// results
		$rows = $this->_db->loadObjectList();
		// checking amount of rows
		if($rows > 0)
		{
			foreach($rows as $row)
			{
				$tmp = array(
					"id" => $row->id,
					"name" => $row->name	
				);
				
				array_push($result_array, $tmp);
			}
		}
		
		//echo '<pre>';
		//echo '====AUTHORS ARRAY====';
		//print_r($result_array);
		//echo '</pre>';
		
		return $result_array;
	}
	// Cookie version of section method
	function getSectionArrayCookie($config, $cookieOrder, $cookieHelper)
	{
		// generating ordering clause
		$section_order = 's.'.$config['section_order'].' '.$config['section_order_type'];
		// generating ordering clause
		$category_order = 'c.'.$config['category_order'].' '.$config['category_order_type'];
		// generating section id clause
		$sectionid_clause = '';
		// iteration
		for($i = 0; $i < count($cookieOrder); $i++)
		{
			$sectionid_clause .= ($i == count($cookieOrder) - 1) ? ' s.id = '.$cookieOrder[$i].' ' : ' s.id = '.$cookieOrder[$i].' OR ';
		}	
		// generating SQL query
		$query =   'SELECT 
						c.title AS cat_name,
			        	c.id AS cat_id,
						c.section AS cat_section,
						s.title AS section_name
					FROM
						#__categories AS c
					INNER JOIN
						#__sections AS s ON s.id = c.section
					WHERE
			        	c.access <= 0 AND
						s.access <= 0 AND
						c.published = 1 AND
			        	s.published = 1 AND
			        	( '.$sectionid_clause.' )
					ORDER BY
			        	'.$section_order.',
						'.$category_order;							
		// running SQL query	
		$this->_db->setQuery($query);
		// getting results rows
		$rows = $this->_db->loadObjectList();
		// parsing rows
		if(count($rows) > 0)
		{
			// creating array for results
			$result_array = array();
			// rows iteration
			foreach($rows as $row)
			{
				$tmp = array(
					"cat_name" => $row->cat_name,
					"cat_id" => $row->cat_id,
					"cat_section" => $row->cat_section,
					"section_name" => $row->section_name
				);
				
				array_push($result_array, $tmp);
			}
			
			// cleaning $sectionArray
			$section_iter = 0;
			// iterating sectionArray
			foreach($result_array as $section)
			{
				// getting section id
				$tmp_section_id = $cookieHelper->ordering[$section_iter];
				// initializing array for categories
				$categories_ids = array();
				// creating array with necessary categories
				foreach($cookieHelper->categories as $element)
				{
					foreach($element as $item)
					{
						array_push($categories_ids, $item);
					}
				}
								
				if(array_search($section["cat_id"], $categories_ids) === FALSE)
				{
					unset($result_array[$section_iter]);				
				}	
				
				$section_iter++;
			}
			
			//echo '<pre>';
			//echo '====SECTION QUERY====';
			//print_r($result_array);
			//echo '</pre>';
			// returnig results in array
			return $result_array;
		}
		else
		{
			// Error - no sections or categories
		}
	}
	// Cookie version of category method
	function getCategoryArrayCookie($config, $sectionArray, $cookieHelper)
	{
		// getting information about user
		$user =& JFactory::getUser();
		$userId = (int) $user->get('id');
		$aid = $user->get('aid', 0);
		// getting access config
		$contentConfig = &JComponentHelper::getParams( 'com_content' );
		$access	= !$contentConfig->get('show_noauth');
		// getting date variables
		$nullDate	= $this->_db->getNullDate();
		$date =& JFactory::getDate();
		$now = $date->toMySQL();
			
		// initializing result array
		$result_array = array();
		// generating queries for every category
		foreach($sectionArray as $section)
		{
			// creating array for category articles
			if(!isset($result_array["section".$section["cat_section"]]['cat'.$section["cat_id"]]))
			{
				$result_array["section".$section["cat_section"]]['cat'.$section["cat_id"]] = array();
			}
			
			// generating ordering clause
			$category_order = 'c.'.$config['category_order'].' '.$config['category_order_type'];
			
			// preparing query
			$query =   'SELECT 
							a.id AS art_id,
							a.title AS art_title, 
							a.introtext AS art_text,
							'.(($config['date_type'] == 'created') ? 'a.created' : 'a.modified').' AS art_date,
							a.created_by AS art_author,
							a.hits AS art_hits,
							a.sectionid AS art_sectionid,
							CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) 
							ELSE a.id END AS art_slug, 
							CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(":", c.id, c.alias) 
							ELSE c.id END AS cat_slug
						FROM 
							#__content AS a 
						INNER JOIN 
							#__categories AS c ON c.id = a.catid 
						WHERE 
						
						a.state = 1 AND 
						( a.publish_up = '.$this->_db->Quote($nullDate).' OR a.publish_up <= '.$this->_db->Quote($now).' ) AND 
						( a.publish_down = '.$this->_db->Quote($nullDate).' OR a.publish_down >= '.$this->_db->Quote($now).' ) AND 
						'.($access ? ' a.access <= ' .(int) $aid. ' AND c.access <= ' .(int) $aid . ' AND ' : '').' 
						c.published = 1 AND 
						a.catid = '.$section["cat_id"].'
						
						ORDER BY 
							'.$category_order.', 
							a.created DESC';
			// run query
			$limit = ($cookieHelper->intro["section".$section["cat_section"]] + $cookieHelper->more["section".$section["cat_section"]] <= 15) ? $cookieHelper->intro["section".$section["cat_section"]] + $cookieHelper->more["section".$section["cat_section"]] : 15;
			$this->_db->setQuery($query,0,$limit);
			// getting query result
			$rows = $this->_db->loadObjectList();
			
			// increasing value of counter
			$counter["section".$section["cat_section"]] += 1;
			// parsing rows
			if(count($rows) > 0)
			{
				// rows iteration
				foreach($rows as $row)
				{
					$tmp = array(
						"art_id" => $row->art_id,
						"art_title" => $row->art_title,
						"art_text" => $row->art_text,
						"art_date" => $row->art_date,
						"art_author" => $row->art_author,
						"art_hits" => $row->art_hits,
						"art_sectionid" => $row->art_sectionid,
						"art_slug" => $row->art_slug,
						"cat_slug" => $row->cat_slug
					);
					
					array_push($result_array["section".$tmp["art_sectionid"]]['cat'.$section["cat_id"]], $tmp);
				}
			}
			else
			{
				// Error - no categories or no articles
			}	
		}
		
		//echo '<pre>';
		//echo '====CATEGORY QUERY====';
		//print_r($result_array);
		//echo '</pre>';
		// returnig results in array
		
		return $result_array;
	}
	// Cookie version of section method
	function getSectionArrayAJAX($section_id, $cats, $cat_order, $cat_order_type)
	{
		// generating ordering clause
		$category_order = 'c.'.$cat_order.' '.$cat_order_type;
		// generating category clause
		$categories = explode('-', $cats);
		$category_clause = '';
		for($i = 0; $i < count($categories); $i++)
		{
			if($i == 0) $category_clause .= ' c.id = '.$categories[$i].' ';
			else $category_clause .= ' OR c.id = '.$categories[$i].' ';
		}	
		// generating SQL query
		$query =   'SELECT 
						c.title AS cat_name,
			        	c.id AS cat_id,
						c.section AS cat_section,
						s.title AS section_name
					FROM
						#__categories AS c
					INNER JOIN
						#__sections AS s ON s.id = c.section
					WHERE
			        	c.access <= 0 AND
						s.access <= 0 AND
						c.published = 1 AND
			        	s.published = 1 AND
			        	s.id = '.$section_id.' AND
			        	( '.$category_clause.' )
					ORDER BY
						'.$category_order;							
		// running SQL query	
		$this->_db->setQuery($query);
		// getting results rows
		$rows = $this->_db->loadObjectList();
		// parsing rows
		if(count($rows) > 0)
		{
			// creating array for results
			$result_array = array();
			// rows iteration
			foreach($rows as $row)
			{
				$tmp = array(
					"cat_name" => $row->cat_name,
					"cat_id" => $row->cat_id,
					"cat_section" => $row->cat_section,
					"section_name" => $row->section_name
				);
				
				array_push($result_array, $tmp);
			}
			
			//echo '<pre>';
			//echo '====SECTION QUERY====';
			//print_r($result_array);
			//echo '</pre>';exit();
			// returnig results in array
			return $result_array;
		}
		else
		{
			// Error - no sections or categories
		}
	}
	// Cookie version of category method
	function getCategoryArrayAJAX($sectionArray, $cat_order, $cat_order_type, $date_type, $intro_amount, $more_amount)
	{
		// getting information about user
		$user =& JFactory::getUser();
		$userId = (int) $user->get('id');
		$aid = $user->get('aid', 0);
		// getting access config
		$contentConfig = &JComponentHelper::getParams( 'com_content' );
		$access	= !$contentConfig->get('show_noauth');
		// getting date variables
		$nullDate	= $this->_db->getNullDate();
		$date =& JFactory::getDate();
		$now = $date->toMySQL();
			
		// initializing result array
		$result_array = array();
		// generating queries for every category
		foreach($sectionArray as $section)
		{
			// creating array for category articles
			if(!isset($result_array["section".$section["cat_section"]]['cat'.$section["cat_id"]]))
			{
				$result_array["section".$section["cat_section"]]['cat'.$section["cat_id"]] = array();
			}
			
			// generating ordering clause
			$category_order = 'c.'.$cat_order.' '.$cat_order_type;
			
			// preparing query
			$query =   'SELECT 
							a.id AS art_id,
							a.title AS art_title, 
							a.introtext AS art_text,
							'.(($date_type == 'created') ? 'a.created' : 'a.modified').' AS art_date,
							a.created_by AS art_author,
							a.hits AS art_hits,
							a.sectionid AS art_sectionid,
							CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) 
							ELSE a.id END AS art_slug, 
							CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(":", c.id, c.alias) 
							ELSE c.id END AS cat_slug
						FROM 
							#__content AS a 
						INNER JOIN 
							#__categories AS c ON c.id = a.catid 
						WHERE 
						
						a.state = 1 AND 
						( a.publish_up = '.$this->_db->Quote($nullDate).' OR a.publish_up <= '.$this->_db->Quote($now).' ) AND 
						( a.publish_down = '.$this->_db->Quote($nullDate).' OR a.publish_down >= '.$this->_db->Quote($now).' ) AND 
						'.($access ? ' a.access <= ' .(int) $aid. ' AND c.access <= ' .(int) $aid . ' AND ' : '').' 
						c.published = 1 AND 
						a.catid = '.$section["cat_id"].'
						
						ORDER BY 
							'.$category_order.', 
							a.created DESC';
			// run query
			$limit = ($intro_amount + $more_amount <= 15) ? $intro_amount + $more_amount : 15;
			$this->_db->setQuery($query,0,$limit);
			// getting query result
			$rows = $this->_db->loadObjectList();
			
			// increasing value of counter
			$counter["section".$section["cat_section"]] += 1;
			// parsing rows
			if(count($rows) > 0)
			{
				// rows iteration
				foreach($rows as $row)
				{
					$tmp = array(
						"art_id" => $row->art_id,
						"art_title" => $row->art_title,
						"art_text" => $row->art_text,
						"art_date" => $row->art_date,
						"art_author" => $row->art_author,
						"art_hits" => $row->art_hits,
						"art_sectionid" => $row->art_sectionid,
						"art_slug" => $row->art_slug,
						"cat_slug" => $row->cat_slug
					);
					
					array_push($result_array["section".$tmp["art_sectionid"]]['cat'.$section["cat_id"]], $tmp);
				}
			}
			else
			{
				// Error - no categories or no articles
			}	
		}
		
		//echo '<pre>';
		//echo '====CATEGORY QUERY====';
		//print_r($result_array);
		//echo '</pre>';
		// returnig results in array
		
		return $result_array;
	}
	//
	function getAuthorArrayAJAX($categoryArray, $author_name)
	{
		// result array
		$result_array = array();
		// preparing array for authors IDs
		$authorIDs = array();
		// search author items
		foreach($categoryArray as $section)
		{
			foreach($section as $category)
			{
				foreach($category as $article)				
				{
					if(array_search($article["art_author"], $authorIDs) === FALSE)
					{
						array_push($authorIDs, $article["art_author"]);
					}
				}
			}
		}
		// variable for cluase
		$authorid_clause = '';
		// generating where clause 
		for($i = 0; $i < count($authorIDs); $i++)
		{
			$authorid_clause .= ($i == count($authorid_clause) - 1) ? ' u.id = '.$authorIDs[$i].' ' : ' u.id = '.$authorIDs[$i].' OR ';
		}
		// generating SQL query
		$query =   'SELECT 
						u.id AS id, 
						u.'.($author_name).' AS name 
					FROM 
						#__users AS u
					WHERE
					'.$authorid_clause;
		// getting data from database
		$this->_db->setQuery($query);
		// results
		$rows = $this->_db->loadObjectList();
		// checking amount of rows
		if($rows > 0)
		{
			foreach($rows as $row)
			{
				$tmp = array(
					"id" => $row->id,
					"name" => $row->name	
				);
				
				array_push($result_array, $tmp);
			}
		}
		
		//echo '<pre>';
		//echo '====AUTHORS ARRAY====';
		//print_r($result_array);
		//echo '</pre>';
		
		return $result_array;
	}
}