<?php

/**
* GK News - main helper class
* @package Joomla!
* @Copyright (C) 2009 Gavick.com
* @ All rights reserved
* @ Joomla! is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.0.0 $
**/

// no direct access
defined('_JEXEC') or die('Restricted access');
// import com_content route helper
require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');
// import JString class for UTF-8 problems
jimport('joomla.utilities.string'); 
// Main class
class GKNews_MainHelper
{
	// section array (stores information about categories in sections)
	var $_sectionArray;
	var $_additionalSectionArray;// (used in cookie mode)
	// category array (stores information about articles in categories)
	var $_categoryArray;
	// author array (stores information about articles authors)
	var $_authorArray;
	// config array (stores information about module settings)
	var $_config;
	// cookie existing
	var $_cookieExists;
	// cookie helper
	var $_cookieHelper;
	// constructor
	function GKNews_MainHelper()
	{
		// creating array for sections categories
		$this->_sectionArray = array();
		// creating array for categories articles
		$this->_categoryArray = array();
		// creating array for articles authors data
		$this->_authorArray = array();
		// creating array for configuration
		$this->_config = array();
		// settings cookie variable
		$this->_cookieExists = false;
		// initializing cookie helper
		$this->_cookieHelper = false;
		// additional sectionArray
		$this->_additionalSectionArray = array();
	}
	// method to get module settings
	function getParams(&$params)
	{
		// Basic module settings
		$this->_config["moduleclass_sfx"]      = (string) $params->get('moduleclass_sfx',       '');
		$this->_config["module_unique_id"]     = (string) $params->get('module_unique_id',      'gknews1');
		// Content source settings
		$this->_config["sections"]             =          $params->get('sections',              '');
		$this->_config["section_order"]        = (string) $params->get('section_order',         'title');
		$this->_config["section_order_type"]   = (string) $params->get('section_order_type',    'ASC');
		$this->_config["cat_amount"]           = (int)    $params->get('cat_amount',            3);
		$this->_config["intro_news_amount"]    = (int)    $params->get('intro_news_amount',     1);
		$this->_config["more_news_amount"]     = (int)    $params->get('more_news_amount',      3);
		$this->_config["col_amount"]           = (int)    $params->get('col_amount',            3);
		$this->_config["category_order"]       = (string) $params->get('category_order',        'title');
		$this->_config["category_order_type"]  = (string) $params->get('category_order_type',   'ASC');
		// Interface settings
		$this->_config["section_sliding"]      = (bool)   $params->get('section_sliding',       1);
		$this->_config["section_options"]      = (bool)   $params->get('section_options',       1);
		$this->_config["options_categories_cols"] = (int)  $params->get('options_categories_cols', 2);
		$this->_config["animation_type"]       =          $params->get('animation_type',        'Fx.Transitions.linear');
		$this->_config["animation_time"]       = (int)    $params->get('animation_time',        500);
		// Content settings
		$this->_config["title_limit"]          = (int)    $params->get('title_limit',           30);
		$this->_config["title_limit_type"]     = (int)    $params->get('title_limit_type',      1);
		$this->_config["text_limit"]           = (int)    $params->get('text_limit',            30);
		$this->_config["text_limit_type"]      = (int)    $params->get('text_limit_type',       1);
		$this->_config["date_type"]            = (string) $params->get('date_type',             'created');
		$this->_config["date_format"]          = (string) $params->get('date_format',           'D, d M Y');
		$this->_config["author_name"]          = (string) $params->get('author_name',           'name');
		$this->_config["clean_xhtml"]          = (bool)   $params->get('clean_xhtml',           1);
		// Image settings
		$this->_config["image_generation"]     = (bool)   $params->get('image_generation',      1);
		$this->_config["image_height"]         = (int)    $params->get('image_height',          128);
		$this->_config["image_width"]          = (int)    $params->get('image_width',           128);
		$this->_config["image_bg"]             = (string) $params->get('image_bg',              '#fff');
		$this->_config["image_stretch"]        = (int)    $params->get('image_stretch',         1);
		$this->_config["image_quality"]        = (int)    $params->get('image_quality',         95);
		$this->_config["cache_time"]           = (int)    $params->get('cache_time',            30);
		// Design settings
		//$this->_config["section_headers"]      = (string) $params->get('section_headers',       '');
		$this->_config["category_template"]    =          $params->get('category_template',     'layout1.php');
		$this->_config["intro_template"]       =          $params->get('intro_template',        'layout1.php');
		$this->_config["more_template"]        =          $params->get('more_template',         'layout1.php');
		// Advanced settings
		$this->_config["parse_plugins"]        = (int)    $params->get('parse_plugins',         0);
		$this->_config["clean_plugins"]        = (int)    $params->get('clean_plugins',         0);
		$this->_config["useCSS"]               = (bool)   $params->get('useCSS',                1);
		$this->_config["useMoo"]               = (int)    $params->get('useMoo',                2);
		$this->_config["useScript"]            = (int)    $params->get('useScript',             2);
		// Data validation
	}
	// method to get module data
	function getDatas()
	{
		// creating and initializing cookie helper
		$this->_cookieHelper = new GKNews_CookieHelper();
		// getting cookie data (if exists)
		$this->_cookieExists = $this->_cookieHelper->init($_COOKIE['gk_news-'.$this->_config['module_unique_id']]/*'3,1,2,5:28,27;4,1,2,2:29;'*/);
		// creating Database Helper instance
		$dbHelper = new GKNews_DBHelper($this->_config);
		// getting section with categories array
		$this->_sectionArray = ($this->_cookieExists) ? $dbHelper->getSectionArrayCookie($this->_config, $this->_cookieHelper->ordering, $this->_cookieHelper) : $dbHelper->getSectionArray($this->_config);
		if($this->_cookieExists) $this->_additionalSectionArray = $dbHelper->getSectionArray($this->_config);
		// getting categories articles array
		$this->_categoryArray = ($this->_cookieExists) ? $dbHelper->getCategoryArrayCookie($this->_config, $this->_sectionArray, $this->_cookieHelper) : $dbHelper->getCategoryArray($this->_config, $this->_sectionArray);
		// getting authors array
		$this->_authorArray = $dbHelper->getAuthorArray($this->_config, $this->_categoryArray);
		// data validation			
	}
	// method to render module
	function renderModule(&$module)
	{
		// creating and initializing text helper
		$textHelper = new GKNews_TextHelper();
		// creating and initializing date helper
		$dateHelper = new GKNews_DateHelper();
		$dateHelper->init();
		// GENERATING FINAL XHTML CODE START
		// create instances of basic Joomla! classes
		$document =& JFactory::getDocument();
		$uri =& JURI::getInstance();
		// add stylesheets to document header
		if($this->_config["useCSS"] == 1){
			$document->addStyleSheet( $uri->root().'modules/mod_gk_news/css/style.css', 'text/css' );
		}
		// init $headData variable
		$headData = false;
		// add scripts with automatic mode to document header
		if($this->_config['useMoo'] == 2)
		{
			// getting module head section datas
			unset($headData);
			$headData = $document->getHeadData();
			// generate keys of script section
			$headData_keys = array_keys($headData["scripts"]);
			// set variable for false
			$mootools_founded = false;
			// searching phrase mootools in scripts paths
			for($i = 0;$i < count($headData_keys); $i++)
			{
				if(preg_match('/mootools/i', $headData_keys[$i]))
				{
					// if founded set variable to true and break loop
					$mootools_founded = true;
					break;
				}
			}
			// if mootools file doesn't exists in document head section
			if(!$mootools_founded)
			{
				// add new script tag connected with mootools from module
				$headData["scripts"][$uri->root().'modules/mod_gk_news/scripts/mootools.js'] = "text/javascript";
				// if added mootools from module then this operation have sense
				$document->setHeadData($headData);
			}
		}
		
		if($this->_config['useScript'] == 2)
		{
			// getting module head section datas
			unset($headData);
			$headData = $document->getHeadData();
			// generate keys of script section
			$headData_keys = array_keys($headData["scripts"]);
			// set variable for false
			$engine_founded = false;
			// searching phrase mootools in scripts paths
			if(array_search($uri->root().'modules/mod_gk_news/scripts/engine.js', $headData_keys) > 0)
			{
				// if founded set variable to true
				$engine_founded = true;
			}
			// if mootools file doesn't exists in document head section
			if(!$engine_founded)
			{
				// add new script tag connected with mootools from module
				$headData["scripts"][$uri->root().'modules/mod_gk_news/scripts/engine.js'] = "text/javascript";
				// if added mootools from module then this operation have sense
				$document->setHeadData($headData);
			}
		}
		// loading layout for content
		require(JModuleHelper::getLayoutPath('mod_gk_news', 'default'));
		// loading layout for scripts
		require(JModuleHelper::getLayoutPath('mod_gk_news', 'scripts'));	
	}
}