<?php

/**
* GK News - category template
* @package Joomla!
* @Copyright (C) 2009 Gavick.com
* @ All rights reserved
* @ Joomla! is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.0.0 $
**/

// no direct access
defined('_JEXEC') or die('Restricted access');

$cat_class = '';

$cat_amount = ($cat_amount > $this->_config["col_amount"]) ? $this->_config["col_amount"] : $cat_amount; 

switch($cat_amount)
{
	case 1: $cat_class = 'gk_news_cat_100';break;
	case 2: $cat_class = 'gk_news_cat_50';break;
	case 3: $cat_class = 'gk_news_cat_33';break;
	case 4: $cat_class = 'gk_news_cat_25';break;
	case 5: $cat_class = 'gk_news_cat_20';break;
	case 6: $cat_class = 'gk_news_cat_16';break;
	case 7: $cat_class = 'gk_news_cat_14';break;
	case 8: $cat_class = 'gk_news_cat_12';break;
	default:$cat_class = 'gk_news_cat_100';break;
}

$cat_link = JRoute::_(ContentHelperRoute::getCategoryRoute($cat_ID, $section_ID));

// Available variables:
// cat_title
// cat_ID
// section_ID
// cat_amount
// cat_class
// cat_link

?>

<div class="<?php echo $cat_class; ?>">
	<div class="gk_news_cat_wrap<?php if($cat_counter != 0 && $cat_counter % $this->_config['col_amount'] == 0) : ?> last<?php endif; ?>">
		<h3><a href="<?php echo $cat_link; ?>"><?php echo $cat_title; ?></a></h3>

		<?php if($intro_amount > 0) : ?>
			<?php 
				
				$intro_counter = 0;
				
				foreach($this->_categoryArray["section".$section_ID]["cat".$cat_ID] as $article)
				{
					if($intro_counter < $intro_amount){
						$art_id = $article["art_id"];
						$art_title = $article["art_title"];
						$art_title = $textHelper->limitText($this->_config["title_limit_type"],$this->_config["title_limit"],$art_title);
						$art_text = ($this->_config["clean_xhtml"]) ? $textHelper->clearCode($article["art_text"]) : $article["art_text"];
						$art_text = ($this->_config["clean_plugins"]) ? $textHelper->cleanPlugins($art_text) : $art_text;
						$art_text = ($this->_config["parse_plugins"]) ? $textHelper->parsePlugins($art_text) : $art_text;
						$art_text = $textHelper->limitText($this->_config["text_limit_type"],$this->_config["text_limit"],$art_text);
						$art_image_path = GKNews_ImageHelper::returnImageAddress($this->_config, $article["art_text"]);
						$art_date = $dateHelper->news_date($article["art_date"], $this->_config["date_format"]);
						$art_author = $article["art_author"];
						$art_hits = $article["art_hits"];
						$art_slug = $article["art_slug"];
						$cat_slug = $article["cat_slug"];
						
						require(JModuleHelper::getLayoutPath('mod_gk_news', 'intro_art'.DS.str_replace('.php','',$this->_config['intro_template']))); 
						$intro_counter++;
					}
				}
				
			?>
		<?php endif; ?>
		
		<?php if($more_amount > 0 && count($this->_categoryArray["section".$section_ID]["cat".$cat_ID]) > $intro_amount) : ?>
		<ul>
			<?php 
				
				$more_counter = 0;
				$intro_counter = 0;
				
				foreach($this->_categoryArray["section".$section_ID]["cat".$cat_ID] as $article)
				{
					if($more_counter < $more_amount && $intro_counter >= $intro_amount){
						$art_id = $article["art_id"];
						$art_title = $article["art_title"];
						$art_title = $textHelper->limitText($this->_config["title_limit_type"],$this->_config["title_limit"],$art_title);
						$art_date = $dateHelper->news_date($article["art_date"], $this->_config["date_format"]);
						$art_slug = $article["art_slug"];
						$cat_slug = $article["cat_slug"];
						
						require(JModuleHelper::getLayoutPath('mod_gk_news', 'more_art'.DS.str_replace('.php','',$this->_config['more_template']))); 
						$more_counter++;
					}
					
					$intro_counter++;
				}
				
			?>
		</ul>
		<?php endif; ?>
	</div>
</div>